//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: PrintCommand.cpp,v 1.2 2004/08/19 16:52:27 gareth Exp $
//

#include "PrintCommand.hpp"

using namespace DbXml;
using namespace std;

string PrintCommand::getCommandName() const
{
  return "print";
}

string PrintCommand::getBriefHelp() const
{
  return "Prints the last results returned";
}

string PrintCommand::getMoreHelp() const
{
  return
    string("Takes no arguments. This command iterates over the default results\n") +
    string("object, printing the results using the XmlValue::asString() method.");
}

void PrintCommand::execute(Args &args, Environment &env)
{
  if(args.size() != 1) {
    throw CommandException("Wrong number of arguments");
  }
  env.testResults();

  env.results()->reset();
  XmlValue value;
  while(env.results()->next(value)) {
    cout << value.asString() << endl;
  }
}

